///////////////////////////////////////////////////////////////////////////
// Copyright © 2014 Esri. All Rights Reserved.
//
// Licensed under the Apache License Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
///////////////////////////////////////////////////////////////////////////

define([
    'dojo/_base/declare',
    'dojo/dom-construct',
    'dojo/_base/array',
    'jimu/BaseWidget',
    'dojo/_base/lang',
    'jimu/LayerInfos/LayerInfos',
    "esri/symbols/SimpleFillSymbol",
    "esri/symbols/SimpleLineSymbol",
    "esri/layers/FeatureLayer",
    "esri/InfoTemplate",
    'esri/tasks/query',
    "esri/tasks/QueryTask",
    "esri/layers/GraphicsLayer",
    'jimu/dijit/Message',
    'esri/Color',
    'esri/geometry/Extent',
    "esri/graphic",
    'esri/urlUtils',
    './libs/lispa/lispaUtils.js',
    "dojo/Deferred",
    "dojo/promise/all",
    "jimu/PanelManager",
    "jimu/WidgetManager"
],
    function (declare,
        domConstruct,
        array,
        BaseWidget,
        lang,
        LayerInfos,
        SimpleFillSymbol,
        SimpleLineSymbol,
        FeatureLayer,
        InfoTemplate,
        Query,
        QueryTask,
        GraphicsLayer,
        Message,
        Color,
        Extent,
        Graphic,
        urlUtils,
        lispaUtils,
        deferred, all,
        PanelManager,
        WidgetManager
    ) {
        var clazz = declare([BaseWidget], {

            name: 'onstartup-PPC',
            baseClass: 'jimu-widget-onstartup-PPC',
            mapServer: [],
            fileJsonFromWS: null,
            fileJsonAliasRischioValanghe: null,
            fileJsonAliasRischioSismico: null,
            fileJsonAliasRischioIdrogeologico: null,
            fileJsonAliasRischioIdraulico: null,
            fileJsonAliasRischioIncendioBoschivo: null,
			fileJsonAliasRischioDighe: null,
			fileJsonAliasRischioDigheIdraulicoValle: null,

            loadAllJsons: function () {

                var fncGetJsonFile = [];
				//Chiamata in ambiente DIGID/ARUBA                //fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonTEST));//
				//debugger;
                //Chiamata in ambiente ARIA
                fncGetJsonFile.push(this.getFileJsonWhitPost(this.config.urlServerInfoScenari, this.map.elementoCondiviso["IDPIANO"]));

                
                fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonValanghe));
                fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonSismico));
                fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonIdrogeologico));
                fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonIdraulico));
                fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonIncendioBoschivo));
				fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonRischioDighe));
				fncGetJsonFile.push(this.getFileJson(this.config.localPathJsonRischioDigheIdraulicoAValle));


                all(fncGetJsonFile).then(dojo.hitch(this, function (results) {
                    this.fileJsonFromWS = results[0];
                    this.fileJsonAliasRischioValanghe = results[1];
                    this.fileJsonAliasRischioSismico = results[2];
                    this.fileJsonAliasRischioIdrogeologico = results[3];
                    this.fileJsonAliasRischioIdraulico = results[4];
                    this.fileJsonAliasRischioIncendioBoschivo = results[5];
					this.fileJsonAliasRischioDighe = results[6];
					this.fileJsonAliasRischioDigheIdraulicoValle = results[7];
                }));

                this.costruisciContentLayerScenario_Niccolo();
            },
            getFileJsonWhitPost: function(urlWS, idPianoGraph) {

                var obj = { idPiano: idPianoGraph };
                var postDati = JSON.stringify(obj);
                var deferred = new dojo.Deferred();
                dojo.xhrPost({
                    url: urlWS,
                    postData: postDati,
                    handleAs: "json",
                    headers: {
                        "Content-Type": "application/json"
                    },
                    load: lang.hitch(this, function (fset) {
                        console.log("Response::", fset);
                        deferred.resolve(fset);
                    }),
                    error: lang.hitch(this, function (error, scope) {
                        pp = new Message({
                            message: this.nls.emailErrorServer,
                            type: 'message'
                        });
                    })
                });
                return deferred.promise;
            },

            getFileJson: function (subUrl) {
                var deferred = new dojo.Deferred();
                var urlGetJson = subUrl;
                esri.request({
                    url: urlGetJson,
                    load: dojo.hitch(this, function (fset) {
                        deferred.resolve(fset);
                    }),
                    error: function (error) {
                        deferred.errback(error);
                    }
                });
                return deferred.promise;
            },


            startup: function () {
                this.addFilltoArray()
                var contesto = this;
                try {
                    var params = urlUtils.urlToObject(document.location.href);
                    var parameterGET = null;
                    if (params && params.query && params.query.parameters) {
                        parameterGET = params.query.parameters;
                    }
                    if (parameterPOST == "null") {
                        parameterPOST = null;
                    }
                    objJson = lispaUtils.getParameterMerged(parameterGET, parameterPOST)
                } catch (err) {
                    contesto.popupMessage(contesto.nls.errorParametri);
                    return;
                }
                if (objJson == null) {
                    objJson = {};
                }
                //Se non esiste lo creo
                if (this.map.oggettoCondiviso == null) {
                    this.map.oggettoCondiviso = {};
                }
                this.map.oggettoCondiviso.appPPC = objJson.appPPC;
                this.map.oggettoCondiviso.listaEventi = [];
                this.map.oggettoCondiviso.listaEventi.push("Avviato sito Piani di Protezione Civile");

                var appPPC = objJson.appPPC;
                if (appPPC != null || undefined) {
                    console.log("parametri appPPC letti ")
                    console.log(appPPC);
                } else {
                    this.popupMessage("Parametri di input non ricevuti");
                    return;
                }
                this.map.elementoCondiviso = {};
                this.map.elementoCondiviso["IDPIANO"] = appPPC.IdPiano;
                this.map.elementoCondiviso["IDSCENARIO"] = appPPC.IdScenario;
                this.map.elementoCondiviso["IDRISCHIO"] = appPPC.IdRischio;
                this.map.elementoCondiviso["UTENTE"] = appPPC.codiceUtente;
                this.map.elementoCondiviso["TIPO"] = appPPC.tipo;
				
				this.loadAllJsons();
				
                if (appPPC.tipo === 'R') {

                    this.startupRead();

                } else if (appPPC.tipo === 'WA') {

                    this.startupEdit();

                } else if (appPPC.tipo === 'WS') {
                    var query = new Query();
                    query.outFields = ["*"];
                    query.where = "IDSCENARIO = '" + appPPC.IdScenario + "' AND IDPIANO = '" + appPPC.IdPiano + "'";
                    console.log(query.where);
                    var queryTask = new QueryTask(contesto.config.tabellaScenari);
                    queryTask.execute(query,
                        dojo.hitch(this, function (result) {
                            if (result.features.length == 0) {
                                var today = new Date(Date.now()).getTime();
                                var saveObj = {}
                                saveObj["IDPIANO"] = contesto.map.elementoCondiviso["IDPIANO"];
                                saveObj["IDSCENARIO"] = contesto.map.elementoCondiviso["IDSCENARIO"];
                                saveObj["IDRISCHIO"] = contesto.map.elementoCondiviso["IDRISCHIO"];
                                saveObj["STATOPIANO"] = contesto.config.statocheck;
                                saveObj["UTCREAZ"] = contesto.map.elementoCondiviso["UTENTE"];
                                saveObj["UTMODIF"] = contesto.map.elementoCondiviso["UTENTE"];
                                saveObj["DATACREAZ"] = today;
                                saveObj["DATAMODIF"] = today;
                                var featureLayerTabella = new FeatureLayer(contesto.config.tabellaScenari)
                                var graphTemp = new Graphic(null, null, saveObj, null)
								console.log("graph Temp");
                                setTimeout(function(){
                                    featureLayerTabella.applyEdits([graphTemp], null, null, function (result) {
                                        //TIP: se il salvataggio delle modifiche alla tabella termina correttamente allora richiamo lo startup dello scenario
                                        contesto.startupScenario();
                                    }, function (error) {
                                        contesto.popupMessage(contesto.nls.systemError);
                                        contesto.map.removeAllLayers();
                                    })
                                },1500)
                            } else {
                                var stato = result.features[0].attributes["STATOPIANO"]
                                if (stato != contesto.config.statocheck) {
                                    contesto.map.removeAllLayers();
                                    //esplode
                                } else {
                                    var today = new Date(Date.now()).getTime();

                                    var saveObj = result.features[0].attributes
                                    saveObj["UTMODIF"] = contesto.map.elementoCondiviso["UTENTE"];
                                    saveObj["DATAMODIF"] = today;
                                    var featureLayerTabella = new FeatureLayer(contesto.config.tabellaScenari)
                                    var graphTemp = new Graphic(null, null, saveObj, null)
									console.log("graphTemp::", graphTemp);
                                    setTimeout(function(){
                                        featureLayerTabella.applyEdits(null, [graphTemp], null, function (result) {
                                            //TIP: se il salvataggio delle modifiche alla tabella termina correttamente allora richiamo lo startup dello scenario
                                            contesto.startupScenario();
                                        }, function (error) {
                                            console.log(error)
                                            contesto.popupMessage(contesto.nls.systemError);
                                            contesto.map.removeAllLayers();
                                        })
                                    },1500)
                                }
                            }


                        }),
                        function (result) {
                            contesto.popupMessage(contesto.nls.errorQuery);
                        });
                    //se risponde no(risultato lengh == 0) o si e stato == BOZZA avanti (startupScenario) se risponde si e stato != BOZZA esplode 
                    //se risponde no devo creare la riga prima di andare avanti: apply edit
                    //contesto.startupScenario();
                }


            },



            costruisciContentLayerScenario: function () {

                var contesto = this;
                //dojo.connect(this.map, "onClick", function () { alert("click sulla mappa.");})
                //console.clear();

                array.forEach(contesto.map.layerIds, dojo.hitch(contesto, function (layerId) {

                    var layerScenari = this.map.getLayer(layerId);

                    if (layerScenari.url == contesto.config.MapServerScenari) {
                        //
                        var idlayer = layerScenari.id;
                        var titoloLayer = layerScenari.arcgisProps.title;
                        //
                        this.map.removeLayer(layerScenari);
                        //Prende l'infoTemplates usando un featureLayer
                        var url = contesto.config.MapServerScenari;
                        var fl = new esri.layers.ArcGISDynamicMapServiceLayer(url, {
                            id: idlayer
                        });

                        var template = new InfoTemplate();
                        template.setTitle('&nbsp;');

                        //var fnc = dojo.hitch(this, "getContentScenarioFromJSON");
                        template.setContent(dojo.hitch(this, "getContentScenarioFromJSON")); //postContentScenario, getTextContent,"getContentScenarioFromJSON"));

                        var infoTemps = ({
                            0: { infoTemplate: template }
                        });
                        fl.setInfoTemplates(infoTemps);
                        fl.arcgisProps = { title: titoloLayer };// layerScenari.arcgisProps;
                        //
                        this.map.addLayer(fl);
                        //
                    }
                }));

            },
            costruisciContentLayerScenario_Niccolo: function () {

                var contesto = this;
                //dojo.connect(this.map, "onClick", function () { alert("click sulla mappa.");})
                //console.clear();

                array.forEach(contesto.map.layerIds, dojo.hitch(contesto, function (layerId) {

                    var layerScenari = this.map.getLayer(layerId);

                    if (layerScenari.url == contesto.config.MapServerScenari) {
                        var template = new InfoTemplate();
                        template.setTitle('&nbsp;');
                        template.setContent(dojo.hitch(this, "getContentScenarioFromJSON"));
                        var infoTemps = ({
                            0: { infoTemplate: template }
                        });
                        layerScenari.setInfoTemplates(infoTemps);
                    }
                }));

            },


            isArray: function (obj) {
                var type = Object.prototype.toString.call(obj);
                if (type === "[object Array]") return true;
                return false;
            },

            isObject: function (obj) {
                return (!!obj) && (obj.constructor === Object);
            },

            getValueAliasFromObject: function (myObjValue, myObjAlias, contenitore, livello) {
                //var myObjValue = myDataValanghe["composizioneUCLeCOC"];
                for (var key in myObjValue) {
                    console.log("key::", key, "value::", myObjValue[key]);
                    if (this.isObject(myObjValue[key])) {
                        console.log("oggetto interno");
                        if (myObjAlias && myObjAlias[key]) {
                            var mySubObjAlias = myObjAlias[key];
                            var mySubObyValue = myObjValue[key];

                            if (myObjAlias) this.creaIntestazioneSezione(contenitore, mySubObjAlias["intestazione"], livello + 1)
                            this.getValueAliasFromObject(mySubObyValue, mySubObjAlias, contenitore, livello + 1);

                        } else return;
                    } else {
                        //Controlla se è un array
                        if (this.isArray(myObjValue[key])) {
                            for (var indx = 0; indx < myObjValue[key].length; indx++) {
                                if (myObjAlias) this.creaIntestazioneSezione(contenitore, myObjAlias[key]["intestazione"], livello + 1) //Object.getOwnPropertyNames(myObjValue)[0] /*myObjValue.constructor.name*/);
                                var singOC = myObjValue[key][indx];
                                for (var myKey in singOC) {
                                    //Controlla se l'elemento è anch'esso un oggetto
                                    if (this.isObject(singOC[myKey])) {
                                        //this.creaDivisioneSingoloElemento(contenitore);
                                        this.getValueAliasFromObject(singOC[myKey], myObjAlias[key][myKey], contenitore, livello + 1)
                                    } else {
                                        //Se esiste il corrisponte nell'insieme degli alias allora stampa
                                        if (myObjAlias && myObjAlias[key][myKey]) {
                                            this.creaRigaLabelValore(myObjAlias[key][myKey], singOC[myKey], contenitore, livello + 1);
                                        }
                                    }
                                }
                                //this.creaDivisioneSingoloElemento(contenitore);
                            }
                            return;
                        }
                        else {
                            //if (myObjAlias) this.creaIntestazioneSezione(contenitore, myObjAlias["intestazione"], livello + 1)
                            for (var objKey in myObjValue) {
                                //Controlla se l'elemento è anch'esso un oggetto
                                if (this.isObject(myObjValue[objKey])) {
                                    this.getValueAliasFromObject(myObjValue[objKey], myObjAlias[key][objKey], contenitore, livello)
                                } else {
                                    //Se esiste il corrisponte nell'insieme degli alias allora stampa
                                    if (myObjAlias && myObjAlias[objKey])
                                        this.creaRigaLabelValore(myObjAlias[objKey], myObjValue[objKey], contenitore, livello + 1);
                                }
                            }
                        }
                        return;
                    }
                }
            },

            creaIntestazioneSezione: function (contenitore, strIntestazione, livello, colore) {
                var tab = (10 * livello) + "px;";
                var strIntestazioneTesto = domConstruct.toDom("<div class='IntestazionePopUp' style='padding-top:4px;padding-left:" + tab + "; color:" + colore + "'>" + strIntestazione + "</div>");
                contenitore.appendChild(strIntestazioneTesto);
            },

            creaIntestazioneSottoSezione: function (contenitore, strIntestazione, livello, colore) {
                var tab = (10 * livello) + "px;";
                var strIntestazioneTesto = domConstruct.toDom("<div class='IntestazioneSottoSezionePopUp' style='padding-left:" + tab + "; color:" + colore + "'>" + strIntestazione + "</div>");
                contenitore.appendChild(strIntestazioneTesto);
            },

            creaDivisioneSingoloElemento: function (contenitore) {
                var strSpazioLinea = domConstruct.toDom("<div><hr class='lineadivSingoloElemento'></div>");
                //var strSpazioLinea = domConstruct.toDom("<div style='margin-bottom:2px;'>&nbsp;</div>");
                contenitore.appendChild(strSpazioLinea);
            },

            creaRigaLabelValore: function (label, valore, contenitore, livello) {
                var tab = (10 * livello) + "px;";
                var separatore = ": ";
                switch (label) {
                    case "*":
                    case "-":
                    case "+":
                        separatore = " ";
                        break;
                }

                var rigaLabelValore = domConstruct.toDom("<div class='rigaLabelValore' style='padding-left:" + tab + "' >" +
                    "<b>" + label.toUpperCase() + "</b>" +
                    separatore +
                    valore.toUpperCase() +
                    "</div>");
                contenitore.appendChild(rigaLabelValore);
            },

            getContentScenarioFromJSON: function (graphic) {

                console.log("graphic::", graphic);

                var contenitore = null;

                switch (graphic.attributes["IDRISCHIO"]) {
                    case "VALANGHE":
                        contenitore = this.visualizzaContentValanghe("datiJsonValanghe");
                        break;
                    case "SISMICO":
                        contenitore = this.visualizzaContentSismico("datiJsonSismico");
                        break;
                    case "IDROGEOLOGICO":
                        contenitore = this.visualizzaContentIdrogeologico("datiJsonIdrogeologico");
                        break;

                    case "IDRAULICO":
                        contenitore = this.visualizzaContentIdrico("datiJsonIdrico");
                        break;

                    case "INCENDI_BOSCHIVI":
                        contenitore = this.visualizzaContentIncendioBoschivo("datiJsonIncendioBoschivo");
                        break;
                    case "DIGHE":
                        contenitore = this.visualizzaContentDighe("datiJsonDighe");
                        break

                    case "DIGHEIDRAULICOVALLE":
                        contenitore = this.visualizzaContentDigheIdraulicoAValle("datiJsonDigheIdraulicoAValle");
                        break;

                }

                this.map.infoWindow.resize(450, 400);
                return contenitore;

            },

            //--------INCENDI_BOSCHIVI
            visualizzaContentIncendioBoschivo: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");

				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioIncendiBoschivi === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}
				
                var myData = this.fileJsonFromWS.scenarioRischioIncendiBoschivi.PPC_SRIB_scenario;
                var myConfigAlias = this.fileJsonAliasRischioIncendioBoschivo.aliasRischi.incendio;

                if (Array.isArray(myData.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myData.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioIncendioBoschivo(myData, scenario, myConfigAlias, contenitore, indx);
                    }
                }
                else {
                    var scenario = myData.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioIncendioBoschivo(myData, scenario, myConfigAlias, contenitore, 0);
                }
                return contenitore;
            },
            getSingoloScenarioIncendioBoschivo: function (myData, scenario, myConfigAlias, contenitore, indx) {


                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";
                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                //for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++)
                {
                    //var scenario = myData.scenariRischio.scenarioRischio[indx];
                    //var scenario = myData.scenariRischio.scenarioRischio;
                    //
                    //if (scenario.idScenario == this.map.elementoCondiviso["IDSCENARIO"]) {
					if (scenario.idScenario) {
                        this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1),1 , coloreLiv0);
                        var ordine = ["idScenario"]
                        var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
                        //
                        var ordine = ["nomeScenario", "areaRischio", "orografia", "areaDintorni", "denominazioneEnte", 
										"superficie", "viabilitaForestale", "viabilitaAccesso"]
						var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio.analisiEsposizione;
                        this.creaSezionepopUp(scenario.analisiEsposizione, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreLiv0);
						var ordine = ["popolazioneTotale", "elettromedicali", "disabili" , "portatoriHandicap", "bambini", "anziani", "altro", "note", "flussi"]
						var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio.analisiEsposizione;						
                        this.creaSezionepopUp(scenario.analisiEsposizione, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto, limitatamente al rischio trattato", 1, coloreLiv0);
						singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
						var alisComposizione = singoloAlias.figure.figura;
						var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];
								
							if (Array.isArray(scenario.figure.figura)) {
								for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
									var composizione = scenario.figure.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);								
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.figure.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);	
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}

					    var alisComposizione = myConfigAlias.scenariRischio.scenarioRischio.responsabiliAIB.responsabileAIB;	
						var ordine = ["flagDOS", "recapito", "responsabile"];
								
							if (Array.isArray(scenario.responsabiliAIB.responsabileAIB)) {
								for (var indxStr = 0; indxStr < scenario.responsabiliAIB.responsabileAIB.length; indxStr++) {
									var composizione = scenario.responsabiliAIB.responsabileAIB[indxStr];
										this.creaIntestazioneSezione(contenitore, "Responsabili AIB - " + (indxStr + 1).toString(), 1, coloreGrigio);								
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.responsabiliAIB.responsabileAIB;
									this.creaIntestazioneSezione(contenitore, "Responsabili AIB ", 1, coloreGrigio);	
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}

						
						var ComposizioneRO = scenario.responsabiliOperativi.responsabileOperativo;
                        var alisComposizione = myConfigAlias.scenariRischio.scenarioRischio.responsabiliOperativi.responsabileOperativo;	
						var ordine = ["flagDOS", "recapito", "responsabile"];
								
							if (Array.isArray(scenario.responsabiliOperativi.responsabileOperativo)) {
								for (var indxStr = 0; indxStr < scenario.responsabiliOperativi.responsabileOperativo.length; indxStr++) {
									var composizione = scenario.responsabiliOperativi.responsabileOperativo[indxStr];
										this.creaIntestazioneSezione(contenitore, "Responsabili operativi - " + (indxStr + 1).toString(), 1, coloreGrigio);								
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.responsabiliOperativi.responsabileOperativo;
									this.creaIntestazioneSezione(contenitore, "Responsabili operativi ", 1, coloreGrigio);	
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}
						

						
						var alisComposizione = myConfigAlias.scenariRischio.scenarioRischio.utentiDOS.utenteDOS;	
						var ordine = ["utente", "recapito"];
								
							if (Array.isArray(scenario.utentiDOS.utenteDOS)) {
								for (var indxStr = 0; indxStr < scenario.utentiDOS.utenteDOS.length; indxStr++) {
									var composizione = scenario.utentiDOS.utenteDOS[indxStr];
										this.creaIntestazioneSezione(contenitore, "Utenti DOS - " + (indxStr + 1).toString(), 1, coloreGrigio);								
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.utentiDOS.utenteDOS;
									this.creaIntestazioneSezione(contenitore, "Utenti DOS ", 1, coloreGrigio);	
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}

                        this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "Sezione Fasi di Risposta all'emergenza", 1, coloreLiv0);
                        this.creaIntestazioneSezione(contenitore, "Codice Giallo - attenzione", 1, coloreGiallo);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        var aliasFasiDiRisposta = myConfigAlias.scenariRischio.scenarioRischio.fasiRispostaEmergenza;
                        var alias = aliasFasiDiRisposta.codiceGiallo.attenzione;
                        var elemento = scenario.fasiRispostaEmergenza.codiceGiallo.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        // 
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - attenzione", 1, coloreArancio);
                        alias = aliasFasiDiRisposta.codiceArancio.attenzione;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - preAllarme", 1, coloreArancio);
                        alias = aliasFasiDiRisposta.codiceArancio.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - preAllarme", 1, coloreRosso);
                        alias = aliasFasiDiRisposta.codiceRosso.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - allarme", 1, coloreRosso);
                        alias = aliasFasiDiRisposta.codiceRosso.allarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.allarme;
					    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

                        
						}
                }
                return contenitore;

            },

            //--------IDRICO
            visualizzaContentIdrico: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");
				
				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioIdraulico === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}
				
                var myData = this.fileJsonFromWS.scenarioRischioIdraulico.PPC_SRI_scenario;
                var myConfigAlias = this.fileJsonAliasRischioIdraulico.aliasRischi.idraulico;

                if (Array.isArray(myData.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myData.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioIdrico(myData, scenario, myConfigAlias, contenitore, indx);
                    }
                }
                else {
                    var scenario = myData.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioIdrico(myData, scenario, myConfigAlias, contenitore, 0);
                }
                return contenitore;
            },
            getSingoloScenarioIdrico: function (myData, scenario, myConfigAlias, contenitore, indx) {
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";

                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                //for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++)
                {
                    //var scenario = myData.scenariRischio.scenarioRischio[indx];
                    //var scenario = myData.scenariRischio.scenarioRischio;
                    //
                //    if (scenario.idScenario == this.map.elementoCondiviso["IDSCENARIO"]) {                        
					if (scenario.idScenario) {
                        this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1), 1, coloreLiv0);

                        var ordine = ["idScenario"]
                        var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
						
						                       
                        var ordine = ["nomeScenario","nomeCorso","codArea",
                            "autorita", "altriCorsi", "zona",
                            "graduazioneScenario", "scenarioAtteso"]
						var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio.scenario; 
                        this.creaSezionepopUp(scenario.scenario, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreLiv0);
                        var ordine = ["popolazioneCoinvolta", "elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altro", "note", "flussi"]     
						var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio.scenario; 							
                        this.creaSezionepopUp(scenario.scenario, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
                        singoloAlias = myConfigAlias.scenariRischio.scenarioRischio.metodoPreannuncio;
                        this.creaIntestazioneSezione(contenitore, "METODO DI PREANNUNCIO", 1, coloreLiv0);
                        ordine = ["zonaOmogenea", "modalita", "effettiDanni", "azioni", "scenariIntervento", "codiceAllertamento"];
                        this.creaSezionepopUp(scenario.metodoPreannuncio, singoloAlias, ordine, contenitore, 1);


						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto, limitatamente al rischio trattato", 1, coloreLiv0);
						singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
						var alisComposizione = singoloAlias.figure.figura;
						var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];
								
							if (Array.isArray(scenario.figure.figura)) {
								for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
									var composizione = scenario.figure.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);								
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.figure.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);	
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}

                        //
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "Sezione Fasi di Risposta all'emergenza", 1, coloreLiv0);
                        this.creaIntestazioneSezione(contenitore, "Codice Giallo - attenzione", 1, coloreGiallo);
                        ordine = ["numeriRiferimentiUtili", "attivitaDestinatario", "comunicazione", "fase", "note", "soggetti"];
                        var aliasFasiDiRisposta = myConfigAlias.scenariRischio.scenarioRischio.fasiRispostaEmergenza;
                        var alias = aliasFasiDiRisposta.codiceGiallo.attenzione;
                        var elemento = scenario.fasiRispostaEmergenza.codiceGiallo.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - attenzione", 1, coloreArancio);
                        alias = aliasFasiDiRisposta.codiceArancio.attenzione;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - preAllarme", 1, coloreArancio);
                        alias = aliasFasiDiRisposta.codiceArancio.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - preAllarme", 1, coloreRosso);
                        alias = aliasFasiDiRisposta.codiceRosso.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - allarme", 1, coloreRosso);
                        alias = aliasFasiDiRisposta.codiceRosso.allarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.allarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

						
											
					}
				}
                
                return contenitore;
        },

            //-----IDROGEOLOGICO-------
            visualizzaContentIdrogeologico: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");
				
				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRichioIdrogeologico === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}				
				
                var myData = this.fileJsonFromWS.scenarioRichioIdrogeologico.PPC_SRIG_scenario;
                var myConfigAlias = this.fileJsonAliasRischioIdrogeologico.aliasRischi.idrogeologico;

                if (Array.isArray(myData.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myData.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioIdrogeo(myData, scenario, myConfigAlias, contenitore, indx);
                    }
                }
                else {
                    var scenario = myData.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioIdrogeo(myData, scenario, myConfigAlias, contenitore, 0);
                }
                return contenitore;
            },
            getSingoloScenarioIdrogeo: function (myData, scenario, myConfigAlias, contenitore, indx) {
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";

                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                //for (var indx = 0; indx < myData.scenariRischio.scenarioRischio.length; indx++)
                {
                    //var scenario = myData.scenariRischio.scenarioRischio[indx];
                    //var scenario = myData.scenariRischio.scenarioRischio;

           //         if (scenario.idScenario == this.map.elementoCondiviso["IDSCENARIO"]) {
					  if (scenario.idScenario) {
                        
                        this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx +1), 1, coloreLiv0);

                        var ordine = ["idScenario", "nomeScenario", "luogoZona", "descrizioneGenerale", "possibiliVieComunicazione"]
                        var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreLiv0);
                        var ordine = ["popolazioneTotale", "elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altri", "noteScenario", "flussi"]
                        var singoloAlias = myConfigAlias.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "METODO DI PREANNUNCIO", 1, coloreLiv0);
                        ordine = ["zonaOmogenea", "notePreannuncio"]
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto, limitatamente al rischio trattato", 1, coloreLiv0);
						var alisComposizione = singoloAlias.figure.figura;
						var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];
							
						if (Array.isArray(scenario.figure.figura)) {
							for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
								var composizione = scenario.figure.figura[indxStr];
									this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);								
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}
							}
						else {
								var composizione = scenario.figure.figura;
								this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);	
								this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
							}
						
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "Sezione Fasi di Risposta all'emergenza", 1, coloreLiv0);
                        this.creaIntestazioneSezione(contenitore, "Codice Giallo - attenzione", 1, coloreGiallo);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        var alias = singoloAlias.fasiRispostaEmergenza.codiceGiallo.attenzione;
                        var elemento = scenario.fasiRispostaEmergenza.codiceGiallo.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - attenzione", 1, coloreArancio);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        alias = singoloAlias.fasiRispostaEmergenza.codiceArancio.attenzione;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.attenzione;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Arancio - preAllarme", 1, coloreArancio);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        alias = singoloAlias.fasiRispostaEmergenza.codiceArancio.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceArancio.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - preAllarme", 1, coloreRosso);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        alias = singoloAlias.fasiRispostaEmergenza.codiceRosso.preAllarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.preAllarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
                        this.creaIntestazioneSezione(contenitore, "Codice Rosso - allarme", 1, coloreRosso);
                        ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                        alias = singoloAlias.fasiRispostaEmergenza.codiceRosso.allarme;
                        elemento = scenario.fasiRispostaEmergenza.codiceRosso.allarme;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                        //
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "MISURE DI RIDUZIONE DEL RISCHIO", 1, coloreLiv0);
                        ordine = ["conseguenze", "effettiCollaterali", "danni", "rapporto", "reteMonitoraggio", "popolazioneCoinvolta", "misure"];
                        alias = singoloAlias.misureRiduzioneRischio;
                        elemento = scenario.misureRiduzioneRischio;
                        this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

						
				}
            }
                
                return contenitore;
        },

            //-------------SISMICO
            visualizzaContentSismico: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");
				
				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioSismico === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}				
				
                var myDataSismico = this.fileJsonFromWS.scenarioRischioSismico.PPC_SRS_scenario;
                var myConfigAliasSismico = this.fileJsonAliasRischioSismico.aliasRischi.sismico;

                if (Array.isArray(myDataSismico.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myDataSismico.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myDataSismico.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioSismico(myDataSismico, scenario, myConfigAliasSismico, contenitore, indx);
                    }
                }
                else {
                    var scenario = myDataSismico.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioSismico(myDataSismico, scenario, myConfigAliasSismico, contenitore, 0);
                }
                return contenitore;
            },

            getSingoloScenarioSismico: function (myDataSismico, scenario, myConfigAliasSismico, contenitore, indx)
            {
                console.log("scenario:::", scenario);
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";

                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";

             //   if (scenario.idScenario == this.map.elementoCondiviso["IDSCENARIO"]) {
				  if (scenario.idScenario) {
                    
                    this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1) , 1, coloreLiv0);

                    var ordine = ["idScenario"]
                    var singoloAlias = myConfigAliasSismico.scenariRischio.scenarioRischio;
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
					
                    var ordine = ["nomeScenario"]
                    var singoloAlias = myConfigAliasSismico.scenariRischio.scenarioRischio.analisiEsposizioneRischio;
                    this.creaSezionepopUp(scenario.analisiEsposizioneRischio, singoloAlias, ordine, contenitore, 1);
					
					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreLiv0);
                    //this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreGrigio);
                    var ordine = ["popolazioneTotale", "elettromedicali", "disabili",
                        "portatoriHandicap", "bambini", "anziani", "altro", "note", "flussi"]
                    var singoloAlias = myConfigAliasSismico.scenariRischio.scenarioRischio.analisiEsposizioneRischio;
                    this.creaSezionepopUp(scenario.analisiEsposizioneRischio, singoloAlias, ordine, contenitore, 1);
                    //

					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "Sezione Modalità di intervento, Fasi operative di risposta all'emergenza", 1, coloreLiv0);
                    //this.creaIntestazioneSezione(contenitore, "Sezione Modalità di intervento, Fasi operative di risposta all'emergenza", 1, coloreGrigio);
                    ordine = ["faseEmergenza", "attivitaSoggetti", "comunicazioni", "note"];
                    alias = myConfigAliasSismico.scenariRischio.scenarioRischio.fasiRispostaEmergenza;
                    elemento = scenario.fasiRispostaEmergenza;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

                    			                 
					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto, limitatamente al rischio trattato", 1, coloreLiv0);					
					var singoloAlias = myConfigAliasSismico.scenariRischio.scenarioRischio;
					var alisComposizione = singoloAlias.figure.figura;
					
					var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];
						
					if (Array.isArray(scenario.figure.figura)) {
						for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
							var composizione = scenario.figure.figura[indxStr];
								this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);								
								this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
							}
						}
					else {
							var composizione = scenario.figure.figura;
							this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);	
							this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
						}
				 
                }
                
                return contenitore;
            },

            //----VALANGHE
            visualizzaContentValanghe: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");

				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioValanghe === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}

                var myDataValanghe = this.fileJsonFromWS.scenarioRischioValanghe.PPC_SRV_scenario;
                var myConfigAliasValanghe = this.fileJsonAliasRischioValanghe.aliasRischi.valanghe;

                if (Array.isArray(myDataValanghe.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myDataValanghe.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myDataValanghe.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioValanga(myDataValanghe, scenario, myConfigAliasValanghe, contenitore, indx);
                    }
                }
                else {
                    var scenario = myDataValanghe.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioValanga(myDataValanghe, scenario, myConfigAliasValanghe, contenitore, 0);
                }
                return contenitore;
                //this.creaIntestazioneSezione(contenitore, "SCENARI", 0);
                //for (var indx = 0; indx < myDataValanghe.scenariRischio.scenarioRischio.length; indx++)
            },
            getSingoloScenarioValanga: function (myDataValanghe, scenario, myConfigAliasValanghe, contenitore, indx) {
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";

                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                //var scenario = myDataValanghe.scenariRischio.scenarioRischio[indx];
                //var scenario = myDataValanghe.scenariRischio.scenarioRischio;

           //     if (scenario.idScenario == this.map.elementoCondiviso["IDSCENARIO"]) {
				  if (scenario.idScenario) {
                    
                    this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1), 1, coloreLiv0);
                    var ordine = ["idScenario",
                        "nomeScenario", "indicazione", "numeroValanga", "tipoValanga",
                        "analisiAree", "classificazioneRischio", "frazioniPopolate"]
                    var singoloAlias = myConfigAliasValanghe["scenariRischio"]["scenarioRischio"];
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
					

                    ordine = ["infrastrutture", "opereMitigazione", "statoManutenzione",
                        "isDeliberaApprovazione", "deliberaApprovazione", "zonaOmogenea", "possibiliVieComunicazione",
                        "altriPunti","pista","pidav"];
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
                    //this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv1);
                    ordine = ["areaValanghiva", "localitaIndicata", "note",];
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);

					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreLiv0);
                    //this.creaIntestazioneSezione(contenitore, "POPOLAZIONE COINVOLTA", 1, coloreGrigio);
                    ordine = ["popolazioneTotale", "elettromedicali", "disabili", "portatoriHandicap",
                        "bambini", "anziani", "altro", "flussi"];
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);
					

                    this.creaIntestazioneSezione(contenitore, "Strutture", 1, coloreGrigio);
					
					var alisStruttura = singoloAlias;
					ordine=["isStrutture"];
					this.creaSezionepopUp(scenario, alisStruttura, ordine, contenitore, 1);
					
					alisStruttura = singoloAlias.strutture.struttura;
                    ordine = ["pisteSci", "localita", "gestoreImpianti", "telefono"];
                    if (Array.isArray(scenario.strutture.struttura)) {
                        for (var indxStr = 0; indxStr < scenario.strutture.struttura.length; indxStr++) {
                            var struttura = scenario.strutture.struttura[indxStr];					
														
                            this.creaIntestazioneSezione(contenitore, "Struttura - " + (indxStr + 1).toString(), 1, coloreGrigio);
							
                            this.creaSezionepopUp(struttura, alisStruttura, ordine, contenitore, 1);															
                        }
                    }
                    else {
                        var struttura = scenario.strutture.struttura;
						
                        this.creaIntestazioneSezione(contenitore, "Struttura ", 1, coloreGrigio);
                        this.creaSezionepopUp(struttura, alisStruttura, ordine, contenitore, 1);						
                    }

                    /*this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv1);
                    ordine = ["areaValanghiva", "localitaIndicata", "note",];
                    this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);*/
					
					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto, limitatamente al rischio trattato", 1, coloreLiv0);
					
					var alisComposizione = singoloAlias.figure.figura;
					var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];				
					
						
					if (Array.isArray(scenario.figure.figura)) {
						for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
							var composizione = scenario.figure.figura[indxStr];
								this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);								
								//Consulenza								
								if (Array.isArray(composizione.consulenza)){
									this.creaIntestazioneSottoSezione(contenitore, "CONSULENZA", 1, coloreNero);
									for (var ind = 0; ind < composizione.consulenza.length; ind++) {
										var ordineCons = ["consulenza"];
										var consulenza = { "consulenza": composizione.consulenza[ind] };
										var aliasCons = { "consulenza": "-" };									 
										this.creaSezionepopUp(consulenza, aliasCons, ordineCons, contenitore, 2);										
									}
								}
								else {
									var ordineCons = ["consulenza"];
									var consulenza = { "consulenza": composizione.consulenza};
									var aliasCons = { "consulenza": "CONSULENZA" };
									this.creaSezionepopUp(consulenza, aliasCons, ordineCons, contenitore, 1);								
							}
								this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
							}
						}
					else {
							var composizione = scenario.figure.figura;
							this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);	
							//Consulenza
							if (Array.isArray(composizione.consulenza)) {
								this.creaIntestazioneSottoSezione(contenitore, "CONSULENZA", 1, coloreNero);
								for (var ind = 0; ind < composizione.consulenza.length; ind++) {
									var ordineCons = ["consulenza"];
									var consulenza = { "consulenza": composizione.consulenza[ind] };
									var aliasCons = { "consulenza": "-" };
									this.creaSezionepopUp(consulenza, aliasCons, ordineCons, contenitore, 2);
								}
							}
							
							else {
									var ordineCons = ["consulenza"];
									var consulenza = { "consulenza": composizione.consulenza};
									var aliasCons = { "consulenza": "CONSULENZA" };
									this.creaSezionepopUp(consulenza, aliasCons, ordineCons, contenitore, 1);								
							}
							this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
					}
					
                    //
					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "Sezione Dotazione per la messa in sicurezza della popolazione", 1, coloreLiv0);
                    //this.creaIntestazioneSezione(contenitore, "Sezione Dotazione per la messa in sicurezza della popolazione", 1, coloreGrigio);
                    var aliasMezzi = singoloAlias.dotazioneMessaSicurezza.mezziTrasporto;
                    ordine = ["mezzo", "numero"];
                    if (Array.isArray(scenario.dotazioneMessaSicurezza.mezziTrasporto)) {
                        for (var indxStr = 0; indxStr < scenario.dotazioneMessaSicurezza.mezziTrasporto.length; indxStr++) {
                            var elemento = scenario.dotazioneMessaSicurezza.mezziTrasporto[indxStr];
                            this.creaIntestazioneSezione(contenitore, "Mezzo - " + (indxStr + 1).toString(), 1, coloreGrigio);
                            this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
                        }
                    }
                    else {
                        var elemento = scenario.dotazioneMessaSicurezza.mezziTrasporto;
                        this.creaIntestazioneSezione(contenitore, "Mezzo ", 1, coloreGrigio);
                        this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
                    }


                    this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv1);
                    ordine = ["dotazioneMateriale", "altraDotazioneMateriale", "dotazioneMezzi"];
                    var alias = singoloAlias.dotazioneMessaSicurezza;
                    elemento = scenario.dotazioneMessaSicurezza;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //

                    //this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv0);
                    //ordine = ["strategia", "altriPunti", "misureAttivita"];
                    //alias = singoloAlias;
                    //elemento = scenario;
                    //this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    ////
					
					this.creaDivisioneSingoloElemento(contenitore);
					this.creaIntestazioneSezione(contenitore, "Sezione Fasi di Risposta all'emergenza", 1, coloreLiv0);
                    //this.creaIntestazioneSezione(contenitore, "Sezione Fasi di Risposta all'emergenza", 1, coloreGrigio);
                    this.creaIntestazioneSezione(contenitore, "Codice Giallo - attenzione", 1, coloreGiallo);
                    ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                    alias = singoloAlias.fasiRispostaEmergenza.codiceGiallo.attenzione;
                    elemento = scenario.fasiRispostaEmergenza.codiceGiallo.attenzione;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //
                    this.creaIntestazioneSezione(contenitore, "Codice Arancio - attenzione", 1, coloreArancio);
                    ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                    alias = singoloAlias.fasiRispostaEmergenza.codiceArancio.attenzione;
                    elemento = scenario.fasiRispostaEmergenza.codiceArancio.attenzione;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //
                    this.creaIntestazioneSezione(contenitore, "Codice Arancio - preAllarme", 1, coloreArancio);
                    ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                    alias = singoloAlias.fasiRispostaEmergenza.codiceArancio.preAllarme;
                    elemento = scenario.fasiRispostaEmergenza.codiceArancio.preAllarme;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //
                    this.creaIntestazioneSezione(contenitore, "Codice Rosso - preAllarme", 1, coloreRosso);
                    ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                    alias = singoloAlias.fasiRispostaEmergenza.codiceRosso.preAllarme;
                    elemento = scenario.fasiRispostaEmergenza.codiceRosso.preAllarme;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //
                    this.creaIntestazioneSezione(contenitore, "Codice Rosso - allarme", 1, coloreRosso);
                    ordine = ["fase", "soggetti", "attivitaDestinatario", "numeriRiferimentiUtili", "comunicazione", "note"];
                    alias = singoloAlias.fasiRispostaEmergenza.codiceRosso.allarme;
                    elemento = scenario.fasiRispostaEmergenza.codiceRosso.allarme;
                    this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);
                    //
                    				
					
				}
                
                return contenitore;
            },
            //-------------------------------

            //--------DIGA
            visualizzaContentDighe: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");
				
				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioDighe === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}				
				
                var myDataDighe = this.fileJsonFromWS.scenarioRischioDighe.PPC_SRD_scenario;
                var myConfigAliasDighe = this.fileJsonAliasRischioDighe.aliasRischi.dighe;

                if (Array.isArray(myDataDighe.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myDataDighe.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myDataDighe.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioDighe(myDataDighe, scenario, myConfigAliasDighe, contenitore, indx);
                    }
                }
                else {
                    var scenario = myDataDighe.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioDighe(myDataDighe, scenario, myConfigAliasDighe, contenitore, 0);
                }
                return contenitore;
            },
            getSingoloScenarioDighe: function (myDataDighe, scenario, myConfigAliasDighe, contenitore, indx) {
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";
                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                {
					if (scenario.idScenario) {
                        this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1), 1, coloreLiv0);
                        var ordine = ["idScenario","nomeScenario"]
                        var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "CENTRO ABITATO CON POPOLAZIONE INTERESSATA", 1, coloreLiv0);
                        var ordine = ["centroAbitatoInteressato", "popolazioneCoinvolta","elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altro"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.porzioneCentriAbitati.porzioni;
                        this.creaSezionepopUp(scenario.porzioneCentriAbitati.porzioni, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "LOCALITA CON POPOLAZIONE INTERESSATA", 1, coloreLiv0);
                        var ordine = ["localitaFrazioniInteressate", "popolazioneCoinvolta","elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altro"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.localitaFrazioni.localitaPopolazione;
                        this.creaSezionepopUp(scenario.localitaFrazioni.localitaPopolazione, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FERROVIE INTERESSATE", 1, coloreLiv0);
                        var ordine = ["infrastruttureFerInt"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.localitaFrazioni.infrastruttureFerroviarieInterrotte;
						if (Array.isArray(scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte)) {
								for (var indxStr = 0; indxStr < scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte.length; indxStr++) {
									var composizione = scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte[indxStr];
										this.creaIntestazioneSezione(contenitore, "Infrastruttura - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte;
								this.creaIntestazioneSezione(contenitore, "Infrastruttura ", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "ALTRE VIE", 1, coloreLiv0);
                        var ordine = ["vieComunicazioneInt"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.localitaFrazioni.vieComunicazioneInterrotte;
                        
						if (Array.isArray(scenario.localitaFrazioni.vieComunicazioneInterrotte)) {
								for (var indxStr = 0; indxStr < scenario.localitaFrazioni.vieComunicazioneInterrotte.length; indxStr++) {
									var composizione = scenario.localitaFrazioni.vieComunicazioneInterrotte[indxStr];
										this.creaIntestazioneSezione(contenitore, "Via di comunicazione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.localitaFrazioni.vieComunicazioneInterrotte;
								this.creaIntestazioneSezione(contenitore, "Via di comunicazione", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "ALTRI SERVIZI INTERESSATI", 1, coloreLiv0);
                        var ordine = ["lacualiInteressati", "fluvialiInteressati", "altroInteressato", "reteElettrica", "reteGas", "reteIdrica", "reteFognaria", "reteTelecomunicazioni","altroScenario"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.localitaFrazioni;
                        this.creaSezionepopUp(scenario.localitaFrazioni, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "DOTAZIONE", 1, coloreLiv0);
						singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio;
						var aliasMezzi = singoloAlias.dotazioneMessaSicurezza.tipoMezzi;
						ordine = ["tipoMezzo", "numeroMezzi"];
						if (Array.isArray(scenario.dotazioneMessaSicurezza.tipoMezzi)) {
							for (var indxStr = 0; indxStr < scenario.dotazioneMessaSicurezza.tipoMezzi.length; indxStr++) {
								var elemento = scenario.dotazioneMessaSicurezza.tipoMezzi[indxStr];
								this.creaIntestazioneSezione(contenitore, "Mezzo - " + (indxStr + 1).toString(), 1, coloreGrigio);
								this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
							}
						}
						else {
							var elemento = scenario.dotazioneMessaSicurezza.tipoMezzi;
							this.creaIntestazioneSezione(contenitore, "Mezzo ", 1, coloreGrigio);
							this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
						}
						this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv1);
						ordine = ["dotazioneMateriale", "altraDotazione","dotazioneMezziSgombero"];
						var alias = singoloAlias.dotazioneMessaSicurezza;
						elemento = scenario.dotazioneMessaSicurezza;
						this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "Sezione UCL/COC e altre figure a supporto", 1, coloreLiv0);
						singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio;
						var alisComposizione = singoloAlias.figure.figura;
						var ordine = ["nomeCognome", "telefonoUclCoc","funzione"];
							if (Array.isArray(scenario.figure.figura)) {
								for (var indxStr = 0; indxStr < scenario.figure.figura.length; indxStr++) {
									var composizione = scenario.figure.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.figure.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, alisComposizione, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "UCL/COC VIGILANZA", 1, coloreLiv0);
                        var ordine = ["funzione", "nomeCognome"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata.uclCocVigilanza.figura;
                        if (Array.isArray(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.uclCocVigilanza.figura)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.uclCocVigilanza.figura.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.uclCocVigilanza.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.uclCocVigilanza.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FASE VIGILANZA", 1, coloreLiv0);
                        var ordine = ["verificaScenario"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata, singoloAlias, ordine, contenitore, 1);

                        var ordine = ["verificaDisponibilitaAttesa", "verificaAccessibilitaAttesa"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata.verificaAreeAttesa;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.verificaAreeAttesa)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.verificaAreeAttesa.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.verificaAreeAttesa[indxStr];
										this.creaIntestazioneSezione(contenitore, "Verifica - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.verificaAreeAttesa;
									this.creaIntestazioneSezione(contenitore, "Verifica ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["altraAttivita"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita[indxStr];
										this.creaIntestazioneSezione(contenitore, "Altre attività - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita;
									this.creaIntestazioneSezione(contenitore, "Altre attività ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["monitoraggioPresidio"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata.monitoraggio;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.monitoraggio)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.monitoraggio.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.monitoraggio[indxStr];
										this.creaIntestazioneSezione(contenitore, "Monitoraggio - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.monitoraggio;
									this.creaIntestazioneSezione(contenitore, "Monitoraggio ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						var ordine = ["comunicazioneAggiornamento", "comunicazioneFase","note"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseVigilanzaRinforzata;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "UCL/COC FASE PERICOLO", 1, coloreLiv0);
                        var ordine = ["funzione", "nomeCognome"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura;
                        //this.creaSezionepopUp(scenario.fasiRispostaEmergenza.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura, singoloAlias, ordine, contenitore, 1);
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePericolo.uclCocVigilanza.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
						
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FASE PERICOLO", 1, coloreLiv0);
                        var ordine = ["popolazioneDaEvacuare","trasferimentoPopolazione"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePericolo;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.fasePericolo, singoloAlias, ordine, contenitore, 1);
						
						
						
						var ordine = ["predisposizioneCancello"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePericolo.predisposizioneCancelli;
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePericolo.predisposizioneCancelli)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePericolo.predisposizioneCancelli.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePericolo.predisposizioneCancelli[indxStr];
										this.creaIntestazioneSezione(contenitore, "Predisposizione cancelli- " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePericolo.predisposizioneCancelli;
									this.creaIntestazioneSezione(contenitore, "Predisposizione cancelli", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["altraAttivita"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePericolo.altreAttivita;
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePericolo.altreAttivita)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePericolo.altreAttivita.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePericolo.altreAttivita[indxStr];
										this.creaIntestazioneSezione(contenitore, "Altre attività - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita;
									this.creaIntestazioneSezione(contenitore, "Altre attività ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["comunicazioneFase","note"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePericolo;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.fasePericolo, singoloAlias, ordine, contenitore, 1);
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FASE COLLASSO", 1, coloreLiv0);
						
						var ordine = ["altraAttivita"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseCollasso.altreAttivita;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseCollasso.altreAttivita)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseCollasso.altreAttivita.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseCollasso.altreAttivita[indxStr];
										this.creaIntestazioneSezione(contenitore, "Altre attività - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseVigilanzaRinforzata.altreAttivita;
									this.creaIntestazioneSezione(contenitore, "Altre attività ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
                        var ordine = ["comunicazioneAggiornamento", "comunicazioneFase", "note"]
						var singoloAlias = myConfigAliasDighe.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseCollasso;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseCollasso, singoloAlias, ordine, contenitore, 1);
					}
				}

                return contenitore;
        },
            //--------DIGA IDRAULICO A VALLE
            visualizzaContentDigheIdraulicoAValle: function (datiJson) {
                var contenitore = domConstruct.toDom("<div></div>");
				
				// intercetta errore scenario non caricato correttamente
				if(this.fileJsonFromWS.scenarioRischioDigheIdraulicoAValle === undefined){
	                var strIntestazioneTesto = domConstruct.toDom('<div class="IntestazionePopUp" style="padding-top:4px;padding-left:10px;; color:#CA6812">ATTENZIONE! SCENARIO NON CARICATO CORRETTAMENTE</div>');
	                contenitore.appendChild(strIntestazioneTesto)
					return contenitore;
				}				
				
                var myDataDigheIdraulicoAValle = this.fileJsonFromWS.scenarioRischioDigheIdraulicoAValle.PPC_SRIV_scenario;
                var myConfigAliasDigheIdraulicoAValle = this.fileJsonAliasRischioDigheIdraulicoValle.aliasRischi.digheIdraulicoAValle;

                if (Array.isArray(myDataDigheIdraulicoAValle.scenariRischio.scenarioRischio)) {
                    for (var indx = 0; indx < myDataDigheIdraulicoAValle.scenariRischio.scenarioRischio.length; indx++) {
                        var scenario = myDataDigheIdraulicoAValle.scenariRischio.scenarioRischio[indx];
                        this.getSingoloScenarioIdrico(myDataDigheIdraulicoAValle, scenario, myConfigAliasDigheIdraulicoAValle, contenitore, indx);
                    }
                }
                else {
                    var scenario = myDataDigheIdraulicoAValle.scenariRischio.scenarioRischio;
                    this.getSingoloScenarioIdrico(myDataDigheIdraulicoAValle, scenario, myConfigAliasDigheIdraulicoAValle, contenitore, 0);
                }
                return contenitore;
            },
            getSingoloScenarioIdrico: function (myDataDigheIdraulicoAValle, scenario, myConfigAliasDigheIdraulicoAValle, contenitore, indx) {
                var coloreLiv0 = "#CA6812";
                var coloreLiv1 = "#CA6212";
                var coloreLiv2 = "#C97B08";
                var coloreLiv3 = "#BA1010";

                var coloreNero = "#000000";
                var coloreGrigio = "#878787";
                var coloreRosso = "#FF0000";
                var coloreArancio = "#FFA500";
                var coloreGiallo = "#FADA5E";
                
                {
                    
					if (scenario.idScenario) {
                        this.creaIntestazioneSezione(contenitore, "Scenario di Rischio - " + (indx+1), 1, coloreLiv0);

                        var ordine = ["idScenario","nomeScenario"]
                        var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio;
                        this.creaSezionepopUp(scenario, singoloAlias, ordine, contenitore, 1);

					    this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "CENTRO ABITATO CON POPOLAZIONE INTERESSATA", 1, coloreLiv0);
                        var ordine = ["centroAbitatoInteressato", "popolazioneCoinvolta","elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altro"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.porzioneCentriAbitati.porzioni;
                        if (Array.isArray(scenario.porzioneCentriAbitati.porzioni)) {
								for (var indxStr = 0; indxStr < scenario.porzioneCentriAbitati.porzioni.length; indxStr++) {
									var composizione = scenario.porzioneCentriAbitati.porzioni[indxStr];
										this.creaIntestazioneSezione(contenitore, "Sezione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.porzioneCentriAbitati.porzioni;
								this.creaIntestazioneSezione(contenitore, "Sezione ", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "LOCALITA CON POPOLAZIONE INTERESSATA", 1, coloreLiv0);
                        var ordine = ["localitaFrazioniInteressate", "popolazioneCoinvolta","elettromedicali", "disabili",
                            "portatoriHandicap", "bambini", "anziani", "altro"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.localitaFrazioni.localitaPopolazione;
						if (Array.isArray(scenario.localitaFrazioni.localitaPopolazione)) {
								for (var indxStr = 0; indxStr < scenario.localitaFrazioni.localitaPopolazione.length; indxStr++) {
									var composizione = scenario.localitaFrazioni.localitaPopolazione[indxStr];
										this.creaIntestazioneSezione(contenitore, "Sezione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.localitaFrazioni.localitaPopolazione;
								this.creaIntestazioneSezione(contenitore, "Sezione ", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FERROVIE INTERESSATE", 1, coloreLiv0);
                        var ordine = ["infrastruttureFerInt"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.localitaFrazioni.infrastruttureFerroviarieInterrotte;
						if (Array.isArray(scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte)) {
								for (var indxStr = 0; indxStr < scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte.length; indxStr++) {
									var composizione = scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte[indxStr];
										this.creaIntestazioneSezione(contenitore, "Infrastruttura - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.localitaFrazioni.infrastruttureFerroviarieInterrotte;
								this.creaIntestazioneSezione(contenitore, "Infrastruttura ", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "ALTRE VIE", 1, coloreLiv0);
                        var ordine = ["vieComunicazioneInt"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.localitaFrazioni.vieComunicazioneInterrotte;
                        
						if (Array.isArray(scenario.localitaFrazioni.vieComunicazioneInterrotte)) {
								for (var indxStr = 0; indxStr < scenario.localitaFrazioni.vieComunicazioneInterrotte.length; indxStr++) {
									var composizione = scenario.localitaFrazioni.vieComunicazioneInterrotte[indxStr];
										this.creaIntestazioneSezione(contenitore, "Via di comunicazione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
						else {
								var composizione = scenario.localitaFrazioni.vieComunicazioneInterrotte;
								this.creaIntestazioneSezione(contenitore, "Via di comunicazione", 1, coloreGrigio);
								this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "ALTRI SERVIZI INTERESSATI", 1, coloreLiv0);
                        var ordine = ["lacualiInteressati", "fluvialiInteressati", "altroInteressato", "reteElettrica", "reteGas", "reteIdrica", "reteFognaria", "reteTelecomunicazioni","altroScenario"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.localitaFrazioni;
                        this.creaSezionepopUp(scenario.localitaFrazioni, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
						this.creaIntestazioneSezione(contenitore, "DOTAZIONE", 1, coloreLiv0);
						singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio;
						var aliasMezzi = singoloAlias.dotazioneMessaSicurezza.tipoMezzi;
						ordine = ["tipoMezzo", "numeroMezzi"];
						if (Array.isArray(scenario.dotazioneMessaSicurezza.tipoMezzi)) {
							for (var indxStr = 0; indxStr < scenario.dotazioneMessaSicurezza.tipoMezzi.length; indxStr++) {
								var elemento = scenario.dotazioneMessaSicurezza.tipoMezzi[indxStr];
								this.creaIntestazioneSezione(contenitore, "Mezzo - " + (indxStr + 1).toString(), 1, coloreGrigio);
								this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
							}
						}
						else {
							var elemento = scenario.dotazioneMessaSicurezza.tipoMezzi;
							this.creaIntestazioneSezione(contenitore, "Mezzo ", 1, coloreGrigio);
							this.creaSezionepopUp(elemento, aliasMezzi, ordine, contenitore, 1);
						}


						this.creaIntestazioneSezione(contenitore, "", 1, coloreLiv1);
						ordine = ["dotazioneMateriale", "altraDotazione","dotazioneMezziSgombero"];
						var alias = singoloAlias.dotazioneMessaSicurezza;
						elemento = scenario.dotazioneMessaSicurezza;
						this.creaSezionepopUp(elemento, alias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "UCL/COC FASE PREALLERTA", 1, coloreLiv0);
                        var ordine = ["funzione", "nomeCognome"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePreallerta.uclCocPreallerta.figura;
                        if (Array.isArray(scenario.fasiRispostaEmergenza.fasePreallerta.uclCocPreallerta.figura)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePreallerta.uclCocPreallerta.figura.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.uclCocPreallerta.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.uclCocPreallerta.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
						
						
						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FASE PREALLERTA", 1, coloreLiv0);
                        
						var ordine = ["verificaDisponibilitaAttesa", "verificaAccessibilitaAttesa"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePreallerta.verificaAreeAttesa;
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePreallerta.verificaAreeAttesa)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePreallerta.verificaAreeAttesa.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.verificaAreeAttesa[indxStr];
										this.creaIntestazioneSezione(contenitore, "Verifica - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.verificaAreeAttesa;
									this.creaIntestazioneSezione(contenitore, "Verifica ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["altraAttivita"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePreallerta.altreAttivita;
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePreallerta.altreAttivita)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePreallerta.altreAttivita.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.altreAttivita[indxStr];
										this.creaIntestazioneSezione(contenitore, "Altre attività - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.altreAttivita;
									this.creaIntestazioneSezione(contenitore, "Altre attività ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
						
						var ordine = ["monitoraggioPresidio"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePreallerta.monitoraggio;
						if (Array.isArray(scenario.fasiRispostaEmergenza.fasePreallerta.monitoraggio)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.fasePreallerta.monitoraggio.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.monitoraggio[indxStr];
										this.creaIntestazioneSezione(contenitore, "Monitoraggio - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.fasePreallerta.monitoraggio;
									this.creaIntestazioneSezione(contenitore, "Monitoraggio ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						var ordine = ["comunicazioneFase","note"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseAllerta, singoloAlias, ordine, contenitore, 1);
						
						var ordine = ["comunicazioneAggiornamento", "comunicazioneFase", "note"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.fasePreallerta;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.fasePreallerta, singoloAlias, ordine, contenitore, 1);

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "UCL/COC FASE ALLERTA", 1, coloreLiv0);
                        var ordine = ["funzione", "nomeCognome"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta.uclCocAllerta.figura;
                        if (Array.isArray(scenario.fasiRispostaEmergenza.faseAllerta.uclCocAllerta.figura)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseAllerta.uclCocAllerta.figura.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.uclCocAllerta.figura[indxStr];
										this.creaIntestazioneSezione(contenitore, "Composizione - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.uclCocAllerta.figura;
									this.creaIntestazioneSezione(contenitore, "Composizione ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
						

						this.creaDivisioneSingoloElemento(contenitore);
                        this.creaIntestazioneSezione(contenitore, "FASE ALLERTA", 1, coloreLiv0);
						var ordine = ["popolazioneDaEvacuare","trasferimentoPopolazione"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseAllerta, singoloAlias, ordine, contenitore, 1);
                        
						var ordine = ["predisposizioneCancello"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta.predisposizioneCancelli;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseAllerta.predisposizioneCancelli)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseAllerta.predisposizioneCancelli.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.predisposizioneCancelli[indxStr];
										this.creaIntestazioneSezione(contenitore, "Predisposizione cancelli- " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.predisposizioneCancelli;
									this.creaIntestazioneSezione(contenitore, "Predisposizione cancelli", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["altraAttivita"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta.altreAttivita;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseAllerta.altreAttivita)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseAllerta.altreAttivita.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.altreAttivita[indxStr];
										this.creaIntestazioneSezione(contenitore, "Altre attività - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.altreAttivita;
									this.creaIntestazioneSezione(contenitore, "Altre attività ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}
								
						var ordine = ["monitoraggioPresidio"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta.monitoraggio;
						if (Array.isArray(scenario.fasiRispostaEmergenza.faseAllerta.monitoraggio)) {
								for (var indxStr = 0; indxStr < scenario.fasiRispostaEmergenza.faseAllerta.monitoraggio.length; indxStr++) {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.monitoraggio[indxStr];
										this.creaIntestazioneSezione(contenitore, "Monitoraggio - " + (indxStr + 1).toString(), 1, coloreGrigio);
										this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
									}
								}
							else {
									var composizione = scenario.fasiRispostaEmergenza.faseAllerta.monitoraggio;
									this.creaIntestazioneSezione(contenitore, "Monitoraggio ", 1, coloreGrigio);
									this.creaSezionepopUp(composizione, singoloAlias, ordine, contenitore, 1);
								}

						var ordine = ["comunicazioneFase","note"]
						var singoloAlias = myConfigAliasDigheIdraulicoAValle.scenariRischio.scenarioRischio.fasiRispostaEmergenza.faseAllerta;
                        this.creaSezionepopUp(scenario.fasiRispostaEmergenza.faseAllerta, singoloAlias, ordine, contenitore, 1);
					}
				}

                return contenitore;
        },
            creaSezionepopUp: function (datiJson, aliasJson, ordine, contenitore, livello) {
                for (indx = 0; indx < ordine.length; indx++) {
                    var valore = datiJson[ordine[indx]];
                    var alias = aliasJson[ordine[indx]];
                    //if(valore && alias)
                    //    this.creaRigaLabelValore(alias, valore, contenitore, livello)
                    if (alias)
                        this.creaRigaLabelValore(alias, (valore ? valore : ""), contenitore, livello);
                }


            },



            //getContentScenarioFrom_Post_JSON: function (graphic) {
            //    var defer = new deferred;
            //    console.log("graphic::", graphic);
            //    //
            //    /*
            //     * http://localhost:8081/mutaprocedimenti20/services/rest/serviziCartografico/tematizzazioneCartografico
            //    {"idPiano": "PPC181"}
            //    */

            //    var urlServer = "http://localhost:8080/ViewerPPC/";
            //    var urlGetJson = urlServer + "jsonFiles/ppc_test.json";

            //    dojo.xhrPost({
            //        url: urlGetJson,
            //        handleAs: "json",
            //        load: dojo.hitch(this, function (data) {

            //            //return "objectId::" + graphic.attributes["OBJECTID"];
            //            //console data ricevuto
            //            var myScenarioRischioValanga = data.scenarioRischioValanghe.PPC_SRV_scenario;
            //            var myConfigValanghe = this.config.aliasRischi.valanghe;
            //            console.log("config.aliasRischi.valanghe::", myConfigValanghe);

            //            //costruisci content per :
            //            //Anagrafica
            //            //Composizione OC - sezione ripetute
            //            //Composizione UC - sezione ripetute
            //            //Scenario Rischio
            //            //Strutture - sezione ripetute
            //            //Codici Giallo - Rosso - Arancio
            //            //Figure
            //            //----------- altre da valutare dal XLS ------------

            //            var strDomTest = domConstruct.toDom("<div>objectId::" + graphic.attributes["OBJECTID"] + "</div>");

            //            defer.resolve(strDomTest);

            //            //
            //        }),
            //        error: dojo.hitch(this, function (error, args) {
            //            console.log("An unexpected error occurred: " + error); 
            //        })
            //    });

            //    return defer.promise;

            //},

            startupEdit: function () {
                var contesto = this;
                var appPPC = this.map.oggettoCondiviso.appPPC;
                //Impostazione dei filtri in mappa
                //TODO: Manca la gestione del filtro dato che non ci sono i dati.
                var arrayElementiRimuovere = [];
                LayerInfos.getInstance(this.map, this.map.itemInfo).then(lang.hitch(this, function (layerInfosObject) {
                    layerInfosObject.getLayerInfoArray().forEach(function (layerInfo) {
                        var urlCorrente = layerInfo.layerObject.url;
                        //console.log(urlCorrente);
                        var index = false;
                        for (var x = 0; x < contesto.config.arrayAnagrafiche.length; x++) {
                            if (contesto.config.arrayAnagrafiche[x].indexOf(urlCorrente) >= 0) {
                                var expression = "IDPIANO = '" + appPPC.IdPiano + "'";
                                layerInfo.layerObject.setDefinitionExpression(expression);
                                //layerInfo.layerObject.setVisibility(true);
                                index = true;;
                            }
                        }
                        if (!index) {
							
							var i_ = 0;
							if(objJson?.appPPC.IdRischio !== undefined && objJson?.appPPC.IdPiano !== undefined) {
								if(objJson.appPPC.IdRischio === 'ARIR') {
									if (contesto.config.rischi.ARIR.includes(layerInfo.layerObject.url)) {										
										var expression = "IDPIANO = '" + objJson.appPPC.IdPiano + "'";
										layerInfo.layerObject.setDefinitionExpression(expression);  										
										layerInfo.layerObject.setVisibility(true);
										i_ = 1;
									}
								}
							}
							if (i_ === 0) {								
								arrayElementiRimuovere.push(layerInfo.layerObject)
							}
							
                            //console.log("URL da rimuovere: " + urlCorrente);
                            //contesto.map.removeLayer(layerInfo.layerObject);
                        }
                    });
                }));

                for (var i = 0; i < arrayElementiRimuovere.length; i++) {
                    var layerTemp = arrayElementiRimuovere[i];
                    contesto.map.removeLayer(layerTemp);
                    console.log("URL rimosso: " + layerTemp.url)
                }
            },

            startupScenario: function () {
                var contesto = this;
                var appPPC = this.map.oggettoCondiviso.appPPC;
                //Impostazione dei filtri in mappa
                //TODO: Manca la gestione del filtro dato che non ci sono i dati.
                var arrayElementiRimuovere = [];
                var kind = appPPC.IdRischio.toUpperCase()
                var array = this.config.rischi[kind];

                LayerInfos.getInstance(this.map, this.map.itemInfo).then(lang.hitch(this, function (layerInfosObject) {
                    layerInfosObject.getLayerInfoArray().forEach(function (layerInfo) {
                        var urlCorrente = layerInfo.layerObject.url;
                        //console.log(urlCorrente);
                        var index = false;
                        for (var x = 0; x < array.length; x++) {
                            if (array[x].indexOf(urlCorrente) >= 0) {
                                var expression = null
                                if (urlCorrente.indexOf(contesto.config.FeatureServerINQ) >= 0) {
                                    expression = "IDPIANO = '" + appPPC.IdPiano + "'";
                                    layerInfo.layerObject.setDefinitionExpression(expression);
                                    layerInfo.layerObject.setVisibility(true);
                                } else if (urlCorrente.indexOf(contesto.config.MapServerScenari) >= 0) {
                                    expression = "IDPIANO = '" + appPPC.IdPiano + "' AND IDSCENARIO = '" + appPPC.IdScenario + "'";
                                    layerInfo.layerObject.setLayerDefinitions(new Array(layerInfo.layerObject.layerInfos.length).fill(expression));
                                    var subLayerIds = layerInfo.layerObject.layerInfos.map(function (info) {
                                        return info.id
                                    });
                                    layerInfo.layerObject.setVisibleLayers(subLayerIds);
                                    layerInfo.layerObject.setVisibility(true);
                                } else if (urlCorrente.indexOf(contesto.config.FeatureServerARIR) >= 0) {
									expression = "IDPIANO = '" + appPPC.IdPiano + "'";
									/*if (urlCorrente.endsWith('0') || urlCorrente.endsWith('1')) {
										expression = "IDPIANO = '" + appPPC.IdPiano + "'";
									}
									else {
										expression = "IDPIANO = '" + appPPC.IdPiano + "' AND IDSCENARIO = '" + appPPC.IdScenario + "'";
									}*/                                   
                                    //layerInfo.layerObject.setLayerDefinitions(new Array(layerInfo.layerObject.layerInfos.length).fill(expression));
                                    /*var subLayerIds = layerInfo.layerObject.layerInfos.map(function (info) {
                                        return info.id
                                    });*/
									layerInfo.layerObject.setDefinitionExpression(expression); 								
                                    //layerInfo.layerObject.setVisibleLayers(subLayerIds);
                                    layerInfo.layerObject.setVisibility(true);
                                }
                                index = true;
                            }
                        }
                        if (!index) {
                            arrayElementiRimuovere.push(layerInfo.layerObject)
                            //console.log("URL da rimuovere: " + urlCorrente);
                        }
                    });
                }));

                for (var i = 0; i < arrayElementiRimuovere.length; i++) {
                    var layerTemp = arrayElementiRimuovere[i];
                    contesto.map.removeLayer(layerTemp);
                    //console.log("URL rimosso: " + layerTemp.url)
                }
            },

            filtraLayerAriaVASTA: function (layerInfo, appPPC) {

                //CONSIDERARE COME VIENE INVIATO IL PARAMETRO IDPIANO QUANDO HA UNA SERIE DI VALORI (X1,X2,X3....)
                //if (appPPC.IdRischio == "DIGHEIDRAULICOVALLE") {
                //    expression = "IDPIANO IN ('" + appPPC.IdPiano + "')";
                //    layerInfo.layerObject.setLayerDefinitions(new Array(layerInfo.layerObject.layerInfos.length).fill(expression));
                //    return;
                //}
                var elencoValori = appPPC.IdPiano.split(",");

                let valori = "'" + elencoValori.join("','") + "'";

                expression = "IDPIANO IN(" + valori + ")";
                layerInfo.layerObject.setLayerDefinitions(new Array(layerInfo.layerObject.layerInfos.length).fill(expression));

            },

            startupRead: function () {
                var self = this;

                LayerInfos.getInstance(this.map, this.map.itemInfo).then(function (layerInfosObject) {
                    layerInfosObject.getLayerInfoArray().forEach(function (info) {
                        info.layerObject.setLayerDefinitions(new Array(info.layerObject.layerInfos.length).fill('0=1'));
                        info.layerObject.setVisibility(true);
                        var subLayerIds = info.layerObject.layerInfos.map(function (info) {
                            return info.id
                        });
                        info.layerObject.setVisibleLayers(subLayerIds);
                    });
                })
            },

            popupMessage: function (message) {
                this.map.removeAllLayers();
                var popup = new Message({
                    message: message,
                    buttons: [{
                        label: this.nls.ok,
                        onClick: lang.hitch(this, function () {
                            popup.close();
                        })
                    }]
                });
            },

            addFilltoArray: function () {
                if (!Array.prototype.fill) {
                    Object.defineProperty(Array.prototype, 'fill', {
                        value: function (value) {

                            // Steps 1-2.
                            if (this == null) {
                                throw new TypeError('this is null or not defined');
                            }

                            var O = Object(this);

                            // Steps 3-5.
                            var len = O.length >>> 0;

                            // Steps 6-7.
                            var start = arguments[1];
                            var relativeStart = start >> 0;

                            // Step 8.
                            var k = relativeStart < 0 ?
                                Math.max(len + relativeStart, 0) :
                                Math.min(relativeStart, len);

                            // Steps 9-10.
                            var end = arguments[2];
                            var relativeEnd = end === undefined ?
                                len : end >> 0;

                            // Step 11.
                            var final = relativeEnd < 0 ?
                                Math.max(len + relativeEnd, 0) :
                                Math.min(relativeEnd, len);

                            // Step 12.
                            while (k < final) {
                                O[k] = value;
                                k++;
                            }

                            // Step 13.
                            return O;
                        }
                    });
                }
                if (!Array.prototype.includes) {
                    Array.prototype.includes = function (searchElement /*, fromIndex*/) {
                        'use strict';
                        if (this == null) {
                            throw new TypeError('Array.prototype.includes called on null or undefined');
                        }

                        var O = Object(this);
                        var len = parseInt(O.length, 10) || 0;
                        if (len === 0) {
                            return false;
                        }
                        var n = parseInt(arguments[1], 10) || 0;
                        var k;
                        if (n >= 0) {
                            k = n;
                        } else {
                            k = len + n;
                            if (k < 0) {
                                k = 0;
                            }
                        }
                        var currentElement;
                        while (k < len) {
                            currentElement = O[k];
                            if (searchElement === currentElement ||
                                (searchElement !== searchElement && currentElement !== currentElement)) { // NaN !== NaN
                                return true;
                            }
                            k++;
                        }
                        return false;
                    };
                }
            }
        });

        clazz.inPanel = false;
        clazz.hasUIFile = false;
        return clazz;
    });